// Class definition of User Connection - Will handle all user requests. 
// every instance will be created in a different thread

class UserConnection
{
private:
	struct List
	{
		char *str;
		List *link_ptr;
	};
		//Object Specific Variables
	SOCKET userSocket;
	long lFileSize;
    char *send_buffer;

public:
	UserConnection(void *); // Constructor
	~UserConnection();      // Destructor
	
		// Support Functions

	void ConnectionRole();
	int CheckString(char *, char *);
	char * LoadFile(char *); // Load File into a variable
	char * ExtractAttribute ( char *, int); // Eg. to get XXX in GET XXX \r\n
	void LogFunc(char *,int); // For Logging in Log File
	long GetSize(char *); // To get size of dynamically allocated strings 
						  // _size gives screwing problems.Checked in MSDN too
	void SetFileSize(char *); //Set the internal variable lFileSize to the size
	int SetHeader(char *); // Set the header in Object variable send_buffer
};

	// Function Declarations

UserConnection::UserConnection(void *srvSock)
{
	int iResult;
	userSocket = (SOCKET) srvSock;
		//Set Socket Options for graceful close
	linger l;
		l.l_onoff =  1; 
		l.l_linger = TIMEOUT;  // Linger option has been set so that all data has been sent before the socket closes itself.

	iResult=setsockopt(userSocket,SOL_SOCKET ,SO_LINGER,(char FAR*)&l,sizeof(linger));
	printf("\nopt Error %d\n",WSAGetLastError());

	ConnectionRole();
	
}

UserConnection::~UserConnection()
{
	printf("Object is dead\n");
}


//NOTE: Due to debug problems in _msize and malloc() 
// We are going to use arrays for size of path var.

void UserConnection::ConnectionRole()
{
	
	// ENTRY into Class. Called by constructor

	
	int iBytes=0,iResult,pathpos,iHeaderSize;
	char *strFileBuffer; //Assuming Max size of path = 100

	//--------Initiate Receive Buffer

	char *buffer,tmpbuffer[2],prevbuffer[2]; //prevbuffer[]'\0;
	char *path;

	//printf("ConnectionRole #1.5\n");
	
	buffer=(char *)malloc(MAX_RECEIVE_SIZE); // Max size of main buffer
	if (buffer==NULL)
		{printf("Insufficient memory to create buffer\n");
		exit(0);}
	
	//printf("ConnectionRole #2\n");

	for(iResult=0;iResult<=MAX_RECEIVE_SIZE-1;iResult++)
		buffer[iResult]='\0';

	iResult=1;	
	tmpbuffer[0]='\0';
			// Some changes required in receive buffer for web server
	
	
	do
	{
		iResult = recv(userSocket,tmpbuffer,1,0);
		tmpbuffer[1]='\0';
		strcat(buffer,tmpbuffer);

	//	printf("ConnectionRole #3\n");


		if(iResult >0)
		{
			iBytes=iBytes + iResult;
			


		// WEB SERVER request end in XXX \\n and \r\n ( again )
		if ( !(strcmp(tmpbuffer,"\r")) && !(strcmp(prevbuffer,"\n")) ) // To identify headers as they are separted lile \r\n \r\n 
		{	
			if(pathpos=CheckString(buffer,"GET"))
			{
	//			printf("ConnectionRole #4\n");
				LogFunc("GET Request",sizeof("GET Request"));
	//			printf("ConnectionRole #5\n");	
					
				
				path=(char *)malloc(GetSize(ExtractAttribute(buffer,pathpos))); // ASSUMPTION: Path size = 100
				path = ExtractAttribute(buffer,pathpos);

				
				
				
//				path=ExtractAttribute(buffer,pathpos);
				SetFileSize(path);
				iHeaderSize=SetHeader(path);

				strFileBuffer = (char *)malloc(lFileSize);
				strFileBuffer = LoadFile(path);
				
				//printf("#before Send_buffer = %u File Buffer = %u Header = %d\n",GetSize(send_buffer),GetSize(strFileBuffer),iHeaderSize);
				send_buffer = (char *)realloc(send_buffer,iHeaderSize + lFileSize + 3);
				//printf("#After Send_buffer = %u File Buffer = %u Header = %d\n",GetSize(send_buffer),GetSize(strFileBuffer),iHeaderSize);
				
				if(send_buffer !=NULL)
				{
					// Assign each char of strfilebuffer to send_buffer beacuse strcat giving problems
					for(int iLoop = iHeaderSize;iLoop < iHeaderSize + lFileSize;iLoop++)
					send_buffer[iLoop] = strFileBuffer[iLoop - (iHeaderSize)];
					
					  send_buffer[++iLoop] = '\0';			
			
					send(userSocket,(LPSTR) send_buffer,(iHeaderSize + lFileSize +3),0);  
				}
			
					
				break;

					// Close Socket for receive
				
				//shutdown(userSocket,2); //2 = disable send and recieve
			}
		}
			strcpy(prevbuffer,tmpbuffer); //TEMP
		}
	}while (iResult > 0);

	
				// Do a graceful close
	shutdown(userSocket,1);	 
	closesocket(userSocket);

			// FREE BUFFERS
	free(send_buffer);
	free(buffer);
	free(strFileBuffer); 
    free(path);
	
	
	// Send data after in coming data stops from browser		
}


int UserConnection::CheckString(char *strMain, char *strSearch)
{
		//Define string
   
	unsigned int iLoop,iCount = 0;
	char *temp,tempno=0,iAbspos=0,*tempcheck; // temp is used to store words before \r\n

		
		// Initialize

	temp = (char *)malloc(sizeof(char) * 1000);
	for(iLoop=0;iLoop<=_msize(temp)-1;iLoop++)
		temp[iLoop]='\0';

		//Define Link List

	
	List *mainptr,*tmpptr;
    

	mainptr=(List *)malloc(sizeof(List));	
	tmpptr = mainptr;
	
		// We are going to store every string in an array
		// Store in File
	
	for(iLoop=0;iLoop <= (strlen(strMain)-1);iLoop++)
	{
		while (strMain[iLoop] != '\r' &&  strMain[iLoop+1] != '\n')
		{
	
			if(islower(strMain[iLoop])) //_toupper is an asshole
				temp[tempno++] = _toupper(strMain[iLoop++]);
			else
				temp[tempno++] = strMain[iLoop++];

		}
	
		iLoop++;

		temp[tempno] = '\0';
			//Store in Linked List
		tmpptr->str = (char *) malloc(_msize(temp));	
		strcpy(tmpptr->str,temp);

		tmpptr->link_ptr=(List *) malloc(sizeof(List));
		tmpptr = tmpptr->link_ptr;

		tempno = 0;
		iCount++;
	}

	// Now do search
	
	tmpptr = mainptr;
	printf("-----------\n");

	tempcheck=(char *)malloc(sizeof(strSearch));


	//LogFunc("CheckString Called ",sizeof("CheckString Called "));

	for(iLoop=0;iLoop<=iCount-1;iLoop++)
	{
	
		strncpy(tempcheck,tmpptr->str,sizeof(strSearch)-1);
	
		if(!strcmp(tempcheck,strSearch)) // Return value in relation to main buffer
		{free(tempcheck);return iAbspos+sizeof(strSearch);} // Return value from where attribute string starts
		tmpptr=tmpptr->link_ptr;
		iAbspos += sizeof(tmpptr->str) + 2; // +2 to account for /r/n
	}
	free(tempcheck);
	return 0;
}

		
		// FUNCTION: LoadFile
char * UserConnection::LoadFile(char *strPath)
{
	int fh; // File Handle
	long iFileSize=0;
	
	char *strFileBuffer,*strFinalPath;
	

	strFinalPath=(char *)malloc( _msize(strPath) + sizeof(PATH) + sizeof(char) );
	

	strcpy(strFinalPath,PATH);
	strcat(strFinalPath,strPath); //_msize is used for 

	// Delete 1
	printf("File Request = %s\n",strFinalPath);
	// Delete 0
	
	LogFunc("File Requested ",sizeof("File Requested "));
	LogFunc(strFinalPath,GetSize(strFinalPath));
	
	fh=_open(strFinalPath,_O_BINARY,_S_IREAD); // We will use Low level IO routines
	if(fh == -1)
	{
			return HTTP_404;
	}
	
	iFileSize=_filelength(fh);

		strFileBuffer = (char *)malloc((sizeof(char) * iFileSize)+1); //calloc sets it to NULL
		if (strFileBuffer == NULL)
			printf("Critical Memory Error\n");
		_read(fh,strFileBuffer,iFileSize);
	_close(fh);

	strFileBuffer[iFileSize] = '\0';
	LogFunc("File Load Complete",sizeof("File Load Complete"));
	
	return strFileBuffer;
}



char * UserConnection::ExtractAttribute ( char *str, int iPos)
{
	int iLoop=0;
	char *attr;	

	attr = (char *)malloc(sizeof(char));
	do
	{
		attr[iLoop]=str[iPos + iLoop];
		attr = (char *)realloc(attr,sizeof(char)+_msize(attr));
	} while(attr[iLoop] != '\r' && attr[iLoop++] != ' '); // Check for space also
	attr[iLoop-1] = '\0';
	return attr;	// Return values
}


void UserConnection::LogFunc(char *str,int iSize)
{
	char *strptr;
	FILE *logfp=NULL;
	logfp=fopen(LOG_PATH,"a");
	if( logfp != NULL)
		if((strptr = (char *)malloc(iSize+sizeof(char)*2)) != NULL) // Realloc is giving a problem here
			{
			strcpy(strptr,str);
			strcat(strptr,"\n");
			fprintf(logfp,strptr);
			fclose(logfp);
			free(strptr);}
		else
			printf("Insufficient Memory for buffer");
	logfp=NULL; // Make file pointer void
}


long UserConnection::GetSize(char *str)
{
	long lSize=0;
	while(str[lSize++] != '\0');
	//	printf("Size = %d\n",lSize-1); // TEMP
	return (lSize-1);
}

void UserConnection::SetFileSize(char *strPath)
{
	int fh=0; // File Handle
	long iFileSize=0;
	
	char *strFinalPath;


	strFinalPath=(char *)malloc( GetSize(strPath) + sizeof(PATH) + sizeof(char) );
	

	strcpy(strFinalPath,PATH);
	strcat(strFinalPath,strPath); //_msize is used for 	



	fh=_open(strFinalPath,_O_BINARY,_S_IREAD); // We will use Low level IO routines
	if(fh == -1)
	{
			lFileSize= -1;
	}
	
	lFileSize=_filelength(fh);
	_close(fh);
}


int UserConnection::SetHeader(char *strPath)
{
	int iLoop;
	char strExt[8],strTemp[100],strFileSize[7]; // Taking a array cuz I dont think any exten
	for(iLoop=0;iLoop<8;iLoop++)
		strExt[iLoop] = '\0';
	
	strTemp[0]='\0';
	strFileSize[0]='\0';



		// BUFFER_FORMAT
		// HTTP/1.1 200 OK (HTTP_200)
		// Server: BeluBhai W3SVR (WEB_SERVER_PRODUCT_NAME)
		// Content-type : "text/html" (MIME_TEXT or MIME_JPEG)
		// Content-Length : 10 
	
			send_buffer=(char *)malloc(sizeof(HTTP_200) + sizeof(WEB_SERVER_PRODUCT_NAME));
				strcpy(send_buffer,HTTP_200);
				strcat(send_buffer,WEB_SERVER_PRODUCT_NAME);
		
			// Find out file extension
		iLoop = GetSize(strPath);
		while(strPath[iLoop] != '.')
		{
			strExt[GetSize(strPath) - iLoop] = strPath[iLoop-- -1];
		}
			
			// Path will be in reverse
		
		if(!strcmp(strExt,JPEG)) // File Extension .GIF
				strcpy(strTemp,MIME_IMAGE_JPEG);
		else // HTML
				strcpy(strTemp,MIME_TEXT_HTML);
			
		
		
		_ltoa(lFileSize,strFileSize,10);

		send_buffer=(char *)realloc(send_buffer, GetSize(HTTP_200) + GetSize(WEB_SERVER_PRODUCT_NAME) + GetSize(strTemp) + GetSize(MIME_LENGTH) + GetSize(strFileSize)+4);

		strcat(send_buffer,strTemp);
		strcat(send_buffer,MIME_LENGTH);
		
		strcat(send_buffer,strFileSize);
		strcat(send_buffer,"\r\n\r\n");
		
		//  Return the Size
		//	Return (sizeof(HTTP_200)); ///+ sizeof(WEB_SERVER_PRODUCT_NAME));
		
		printf("%d\n",GetSize(strTemp));
		return (GetSize(HTTP_200) + GetSize(WEB_SERVER_PRODUCT_NAME) + GetSize(strTemp) + GetSize(MIME_LENGTH) + GetSize(strFileSize)+4);
}

